.386
.MODEL FLAT

.CODE
_run:

include         stdparas.inc                            ; PA1-PA4
include         abpstruc.inc                            ; asmBmpPara-structure


; *********************************************************************************************

asmBmpPara      EQU     <PA1>                           ; prg specific values
fct             EQU     <PA2>            
bCol            EQU     <PA3>
wCol            EQU     <PA4>

; *********************************************************************************************

Mono            PROC    NEAR

init:           mac     SAVE
                push    71                              ; => stack1 = red factor
                push    707                             ; => stack2 = green factor
                push    222                             ; => stack3 = blue factor
                push    1000                            ; => stack4 = 1000
                
                mov     ebx,asmBmpPara                  ; initialize loop
                mov     esi,srcBits
                mov     edi,tgtBits
                mov     ecx,tgtWidth
                imul    ecx,tgtHeight

bmp_loop:       lodsd                                   ; change pixels
                xor     ebx,ebx
                mov     edx,ebx
                mov     dl,ah
                mov     bl,al
                imul    ebx,stack1
                imul    edx,stack2
                add     ebx,edx
                shl     eax,8
                shr     eax,24
                mul     stack3
                add     eax,ebx
                div     stack4
                cmp     al,[ebp+12]
                mov     eax,wCol
                jc      bmp_loop_1
                mov     eax,bCol
bmp_loop_1:     stosd
                dec     ecx
                jnz     bmp_loop
                
                stc
finish:         mac     RESTSP

Mono            ENDP

END _run
