Attribute VB_Name = "asm_Mono"
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!

Option Explicit

' asmMono
'
' CALL          asmMono(ptr:lpAsmBmpPara, [fct:factor], [bc], [wc])
'
' IN:           lng:ptr Points to asmBmpPara-structure
'               lng:fct 0 to 255    (default = 128)
'               lng:bc  black-color (default = vbBlack)
'               lng:wc  white-color (default = vbWhite)
'
' OUT:          bol     success
'
Function asmMono(lpAsmBmpPara As Long, Optional fct As Long = 128, Optional _
    bCol As Long = vbBlack, Optional wCol As Long = vbWhite) As Boolean
    
    Static asm(25) As Long
    
    If asm(0) = 0 Then
        asm(0) = &HEC8B5590
        asm(1) = &H6A575653
        asm(2) = &H2C36847
        asm(3) = &HDE680000
        asm(4) = &H68000000
        asm(5) = &H3E8
        asm(6) = &H8B085D8B
        asm(7) = &H7B8B1473
        asm(8) = &H1C4B8B2C
        asm(9) = &H204BAF0F
        asm(10) = &H8BDB33AD
        asm(11) = &H8AD48AD3
        asm(12) = &H5DAF0FD8
        asm(13) = &H55AF0FF0
        asm(14) = &HC1DA03EC
        asm(15) = &HE8C108E0
        asm(16) = &HE865F718
        asm(17) = &H75F7C303
        asm(18) = &HC453AE4
        asm(19) = &H7214458B
        asm(20) = &H10458B03
        asm(21) = &HD07549AB
        asm(22) = &HF4658DF9
        asm(23) = &H5E5FC01B
        asm(24) = &H10C25D5B
        asm(25) = &H0
    End If
    
    ' ************************************************************
    
    asmMono = CallWindowProc(asm(0), lpAsmBmpPara, fct, bCol, wCol)
End Function

' basMono
'
' AUFRUF:       basMono(src, tgt, [fct:Faktor], [bc], [wc]))
'
' EIN:          bar:src Herkunftsdaten        (ByteArray)
'               bar:tgt Zieldaten             (ByteArray)
'               lng:fct Faktor 0 bis 255      (Vorgabe 128)
'               lng:bc  Schwarz               (Vorgabe 0)
'               lng:wc  Wei                  (Vorgabe 16777215)
'
' AUS:          log     Erfolg
'
Function basMono(src() As Byte, tgt() As Byte, Optional fct As Long = 128, _
    Optional bCol As Long = vbBlack, Optional wCol As Long = vbWhite) As Boolean
    
    ' Zhler
    Dim X1       As Long
    
    ' Zhler
    Dim Y1       As Long
    Dim N1       As Long
    
    If fct < 0 Or fct > 255 Then
        MsgBox "invalid parameter fct" & fct
    Else
        
        For Y1 = 1 To UBound(src, 2)
            For X1 = 1 To UBound(src, 1) Step 4
                N1 = ((71& * src(X1 + 0, Y1) + 707& * src(X1 + 1, Y1) + 222& * src(X1 + 2, _
                    Y1)) / 1000) And 255
                
                
                If N1 < fct Then
                    CopyMemory tgt(X1, Y1), wCol, 4
                Else
                    CopyMemory tgt(X1, Y1), bCol, 4
                End If
            Next X1
        Next Y1
        
        basMono = True
    End If
End Function
